/*
 *    for STM32F746 Discovery
 *
 *    Copyright (C) by Hasada & FCT Embedded System Research Circle
 */

#include "lcd_param.h"

void  ili9328_copy_bmp_to_v( unsigned char *bmp, unsigned short int *v_top );
void  ili9328_copy_fb_to_v1( void );
void  ili9328_copy_fb_to_v2( void );
void  ili9328_copy_v_to_r1( void );
void  ili9328_copy_v_to_r2( void );
void  ili9328_disp_lcd( void );
int  imgpro_sdcard_file_check( char *fname );
void  imgpro_sdcard_read( char *fname, unsigned char *buff, int size );
void  imgpro_sdcard_write( char *fname, unsigned char *buff, int size );
void  imgpro_write_bmp_file( unsigned char *photo, char *fname );
void  BSP_CAMERA_Suspend( void );
void  BSP_CAMERA_Resume( void );

extern  int  cam_main_event ;
extern  int  disp_current_lcd ;


void  api_copy_bmp_to_v( unsigned char *bmp, int lcdnum )
{
  if( lcdnum == 1 ) {
    ili9328_copy_bmp_to_v( bmp, (unsigned short int *)DEF_LCD_VUR_FB1 );
  } else {
    ili9328_copy_bmp_to_v( bmp, (unsigned short int *)DEF_LCD_VUR_FB2 );
  }
}


void  api_copy_fb_to_v( int lcdnum )
{
  if( lcdnum == 1 ) {
    ili9328_copy_fb_to_v1();
  } else {
    ili9328_copy_fb_to_v2();
  }
}


void  api_copy_v_to_r( int lcdnum )
{
  if( lcdnum == 1 ) {
    ili9328_copy_v_to_r1();
  } else {
    ili9328_copy_v_to_r2();
  }
}


void  api_disp_lcd( int lcdnum )
{
  if( lcdnum == 1 ) {
    disp_current_lcd = 0;
  } else {
    disp_current_lcd = 1;
  }

  ili9328_disp_lcd();
}


/*
 *  return :  0 : file exists
 *            1 : no file
 *           -1 : access error
 */
int  api_sdcard_file_check( char *fname )
{
  return  imgpro_sdcard_file_check( fname );
}


void  api_sdcard_read( char *fname, unsigned char *buff, int size )
{
  imgpro_sdcard_read( fname, buff, size );
}


void  api_sdcard_write( char *fname, unsigned char *buff, int size )
{
  imgpro_sdcard_write( fname, buff, size );
}


void  api_write_bmp_file( unsigned char *photo, char *fname )
{
  imgpro_write_bmp_file( photo, fname );
}


void  api_camera_stop( void )
{
  BSP_CAMERA_Suspend();
}

void  api_camera_start( void )
{
  BSP_CAMERA_Resume();

  /* claer print event */
  cam_main_event &= ~(0x0002|0x0001);

  /* set print end event */
  cam_main_event |=  0x0004;
}
